require(['aui/inline-dialog2']);
(function($) {

    window.RAVEN = window.RAVEN || {};

    RAVEN.InlineEdit = RAVEN.InlineEdit || {};
    var LCAROUSELSIZE = 6;
    var BASE_SPAN_VALUE = 3;

    /**
     * Run Status
     */
    var TODO = "TODO";
    var EXECUTING = "EXECUTING";
    var PASS = "PASS";
    var FAIL = "FAIL";
    var ABORTED = "ABORTED";

    var testExamplesResult = [];
    var exampleValuesLength = BASE_SPAN_VALUE;
    var testStepsTable;
    var testRunId;
    var isManualTest;
    var isGenericTest;
    var isCucumberTest = false;
    var isCucumberInViewCompatibilityMode = false;
    var isScenarioOutlineTest = false;
    var hasMultipleResults = false;
    var isExamplesEditable = false;
    var canSetRequirementStatus = false;
    var requireExperimentalDialog2 = false;
    var createForm;
    var currentDefectPicker;
    var isGlobalCreateDefect = false;
    var modified;
    var modifiedTestType;
    var currentDropdownTrigger = null;
    var currentExampleView = null;
    var issueTypeDefect = 1;
    var activityStreamView = null;

    var examplesView = null;
    var resultsView = null;
    var requirementStatusView = null;
    var testStepView = null;
    var testRunStatusView = null;

    var readonly = false;

    /**
     * Ace Editor
     */
    var gherkinTheme = require("ace/theme/textmate");
    var preConditionAceEditor;
    var automatedTestAceEditor;

    var fancyboxDefaultOpts = {
        type: "image",
        centerOnScroll: true,

        // disable JIRA's keyboard shortcuts when displaying a lightbox
        onStart: AJS.disableKeyboardShortcuts,
        onClosed: AJS.enableKeyboardShortcuts
    };

    var imageRegex = /([^\s]+(\.(jp(e|g|eg)|gif|png|bmp|jfif|svg|ico))$)/;

    var lcarousel = null;

    function initializeStepAttachmentsList(testStepId){
        RAVEN.Component
            .InlineDialogCarousel
            .createInlineDialogCarousel("#example-step-"+testStepId, "#step-attachments-"+testStepId, "step-attachments");
    }

    function initializePreconditionsAttachmentsList(){
        var inlineDialogComponent = RAVEN.Component.InlineDialogCarousel;
        var preCondNumber = $('#pre-conditions-size').val();
        for (var i = 0; i < preCondNumber; i++) {
            inlineDialogComponent
                .createInlineDialogCarousel(".precond-attachments-"+i, ".list-precond-attachments-"+i, "pre-condition-attachments");

            inlineDialogComponent
                .createInlineDialogCarousel(".expanded-precond-attachments-"+i, ".list-expanded-precond-attachments-"+i, "pre-condition-attachments");
        }
    }

    function checkDefectsSize() {
        if ($("#global-defects-list").children().length === 0) {
            $('#execution-defects-module .mod-content').addClass('no-defects');
            $('#execution-defects-module .mod-content').removeClass('defects');
        } else {
            $('#execution-defects-module .mod-content').addClass('defects');
            $('#execution-defects-module .mod-content').removeClass('no-defects');
        }
    }

    function checkEvidencesSize() {
        if ($("#global-execution-attachments").children().length === 0) {
            $('#execution-attachments-module .mod-content').addClass('no-evidences');
            $('#execution-attachments-module .mod-content').removeClass('evidences');
        } else {
            $('#execution-attachments-module .mod-content').addClass('evidences');
            $('#execution-attachments-module .mod-content').removeClass('no-evidences');
            applyFancybox();
        }
    }

    function message(title, message, type) {
        clearMessage();

        if (type === "warning") {
            AJS.messages.warning('#raven-execute-test-message-bar', {
                title: title,
                body: message
            });
            return;
        }

        AJS.messages.error('#raven-execute-test-message-bar', {
            title: title,
            body: message
        });
    }

    function fixDiv() {
        var $panel = $('#main-panel');
        var $header = $('#page-header');

        if ($panel && $header) {
            if ($(window).scrollTop() > 80) {
                $header.css({
                    'position': 'fixed',
                    'top': '0px',
                    'z-index': '99',
                    'width': $panel.css("width"),
                });
            } else {
                $header.css({
                    'position': 'relative',
                    'top': 'auto',
                    'width': 'auto'
                });
            }
        }
    }


    $(window).scroll(fixDiv);

    var addEvent = function(object, type, callback) {
        if (object == null || typeof(object) == 'undefined') return;
        if (object.addEventListener) {
            object.addEventListener(type, callback, false);
        } else if (object.attachEvent) {
            object.attachEvent("on" + type, callback);
        } else {
            object["on" + type] = callback;
        }
    };

    addEvent(window, "resize", fixDiv);

    function initializeAceEditorComponent() {
        require(['ace/ace'], function(ace) {
            var preCondNumber = $('.execute-precondition-value').length;
            if (preCondNumber > 0) {
                for (var i = 0; i < preCondNumber; i++) {
                    var aceValue = $('.execute-precondition-value')[i].value;
                    var preConditionAceEditorDiv = $('#execute-precondition-ace-editor' + i);
                    preConditionAceEditor = ace.edit("execute-precondition-ace-editor" + i);
                    preConditionAceEditor.setTheme(gherkinTheme);
                    preConditionAceEditor.setFontSize(14);
                    preConditionAceEditor.getSession().setMode("ace/mode/gherkin");
                    preConditionAceEditor.getSession().setUseWrapMode(true)
                    preConditionAceEditor.renderer.setShowGutter(true);
                    preConditionAceEditor.renderer.setShowPrintMargin(false);
                    preConditionAceEditor.getSession().setValue(aceValue);
                    preConditionAceEditor.setReadOnly(true);
                }
            }

            if ($('#execute-test-details-value').length > 0) {
                var aceValue = $('#execute-test-details-value').val();
                $('#execute-test-details-ace-editor');
                var automatedTestAceEditorDiv = $('#execute-test-details-ace-editor');
                automatedTestAceEditor = ace.edit("execute-test-details-ace-editor");
                automatedTestAceEditor.setTheme(gherkinTheme);
                automatedTestAceEditor.setFontSize(14);
                automatedTestAceEditor.getSession().setMode("ace/mode/gherkin");
                automatedTestAceEditor.getSession().setUseWrapMode(false)
                automatedTestAceEditor.renderer.setShowGutter(true);
                automatedTestAceEditor.renderer.setShowPrintMargin(false);
                automatedTestAceEditor.getSession().setValue(aceValue);
                automatedTestAceEditor.setReadOnly(true);
            }
        });
    }

    function clearMessage() {
        $('#raven-execute-test-message-bar').empty();
    }

    function info(title, message) {
        AJS.messages.info('#raven-execute-test-message-bar-info', {
            title: title,
            body: message,
            closeable: false
        });
    }

    function getTestRunId() {
        return $('#test-run-id').val();
    }

    function getTestExecKey() {
        return $('#test-exec-key').val();
    }

    function getApplicationLinks() {
        if ($("#application-links").val()) {
            return JSON.parse($("#application-links").val())
        }
        return null;
    }

    function getTestKey() {
        return $('#test-key').val();
    }

    function hasChanges() {
        if (modified === undefined) {
            modified = $('#modified').val() === 'true';
        }

        return modified;
    }

    function isValidScenarioOutline() {
        return $('#hasParserError').val() === "false";
    }

    function hasChangedTestType() {

        if (modifiedTestType === undefined) {
            modifiedTestType = $('#modified-test-type').val() === 'true';
        }

        return modifiedTestType;
    }

    function updateTestRunStatusFromServer() {
        $('.test-execution-status').block();

        $.ajax({
            type: "GET",
            url: contextPath + '/rest/raven/1.0/testrun/' + testRunId + "/status",
            processData: false,
            async: true,
            contentType: "application/json",
            error: function(qXHR, textStatus, errorThrown) {
                if (errorThrown && errorThrown.trim() != '') {
                    errorThrown = errorThrown + ': ' + qXHR.responseText;
                } else {
                    errorThrown = qXHR.responseText;
                }
                message(AJS.I18n.getText('execute-test-action.status.update.error'), errorThrown)
            },
            success: function(data, textStatus, jqXHR) {
                updateTestRunStatusCallback(data.obj, false);
            },
            complete: function() {
                $('.test-execution-status').unblock();
            }
        });
    }

    function updateTestRunStatusCallback(data, refreshSteps) {

        // sync test step results and test example results
        if (refreshSteps === true) {
            if (isManualTest === 'true') {
                testStepView.initialize();
            } else if (hasMultipleResults === 'true') {
                $('#execution-results-module').remove();

                if (isScenarioOutlineTest === 'true') {
                    $('#execution-examples-module').show();
                    examplesView = renderExamplesSection();
                }
            } else if (isScenarioOutlineTest === 'true') {
                refreshTestExampleResults();
            }
        }

        //update last execution Executed By
        if (data.username) {
            var execBy = $('#test-exec-exec-by');
            execBy.empty();
            execBy.append('<strong><a href="/jira/secure/ViewProfile.jspa?name=' + data.username + '" rel="' + data.username + '" class="user-hover">' + data.fullname + '</a></strong>');
        } else {
            $('#test-exec-start').text('-');
        }

        // set editable if status is final
        if (requirementStatusView) {
            requirementStatusView = new RAVEN.ExecuteTest.RequirementStatusesView({ 'isStatusEditable': data.status.isFinal, 'activityStreamView': activityStreamView });
        }

        // update start date
        if (data.startDate) {
            var start = $('#test-exec-start');
            start.empty();
            start.append('<strong>' + data.startDate + '</strong>');
        } else {
            $('#test-exec-start').text('-');
        }

        // update finish date
        if (data.finishDate) {
            var finish = $('#test-exec-finish');
            finish.empty();
            finish.append('<strong>' + data.finishDate + '</strong>');
        } else {
            $('#test-exec-finish').text('-');
        }
    }

    function displayWorkflowTransitionMessages(errors) {
        if (errors.length > 0) {
            var finalErrors = "";
            for (var i = 0; i < errors.length; i++) {
                finalErrors += errors[i] + "\n";
            }
            message(AJS.I18n.getText('test-execution.workflow-status.error-message.title'), finalErrors, "warning");
        }
    }

    function refreshTestExampleResults() {
        if (examplesView) {
            examplesView.model.fetch({
                reset: true
            });
        }
    }

    var currentEditedRow;

    function addSubTaskDefectsToStepExecution(issue) {

        var appId = $("#jira-app-link").val();
        if (currentEditedRow) {
            var currentDefectPicker = currentEditedRow.issuePicker;
            if (currentDefectPicker) {
                var issueValue = (appId && appId != null && appId != "") ? issue + "&&" + appId : issue;
                var item = new AJS.ItemDescriptor({
                    value: issue.issueKey,
                    label: issue.issueValue,
                    icon: null
                });

                currentDefectPicker.addItem(item);
            }

            currentEditedRow = null;
        }
    }

    function addDefectsToGlobalExecution(issueKeys) {
        $('#content-panel').block();
        clearMessage();

        var path = contextPath + '/rest/raven/1.0/testrun/' + testRunId + '/defects';
        var appId = $("#jira-app-link").val();
        
        
        if (appId && appId != "") {
            path = contextPath + '/rest/raven/1.0/testrun/' + testRunId + '/remotedefects/' + appId;
        }

        var value = JSON.stringify(issueKeys);
        $.ajax({
            type: "POST",
            url: path,
            processData: true,
            async: true,
            data: value,
            contentType: "application/json",
            error: function(qXHR, textStatus, errorThrown) {
                if (errorThrown && errorThrown.trim() != '') {
                    errorThrown = errorThrown + ': ' + qXHR.responseText;
                } else {
                    errorThrown = qXHR.responseText;
                }
                error(AJS.I18n.getText('execute-test-action.defects.add.title'), AJS.I18n.getText('execute-test-action.defects.add.message'));
            },
            success: function(data, textStatus, jqXHR) {
                processAddDefectResults(data);
            },
            complete: function() {
                $('#content-panel').unblock();
            }
        });
    }

    function getDefectFieldsDefaults(dialog, tsrId) {
        var path = null;
        if (tsrId) {
            path = contextPath + '/rest/raven/1.0/testrun/' + testRunId + '/steps/' + tsrId + '/defect/defaults';
        } else {
            path = contextPath + '/rest/raven/1.0/testrun/' + testRunId + '/defect/defaults';
        }

        $.ajax({
            type: "GET",
            url: path,
            processData: true,
            async: false,
            contentType: "application/json",
            error: function(qXHR, textStatus, errorThrown) {
                if (errorThrown && errorThrown.trim() != '') {
                    errorThrown = errorThrown + ': ' + qXHR.responseText;
                } else {
                    errorThrown = qXHR.responseText;
                }
                message(AJS.I18n.getText('execute-test-action.defects.defaults.error.title'), AJS.I18n.getText('execute-test-action.defects.defaults.error.message'));
            },
            success: function(data, textStatus, jqXHR) {
                if (data) {
                    if (data.environment) {
                        dialog.find('#environment').val(data.environment);
                    }

                    if (data.stepDescription) {
                        dialog.find('#description').val(data.stepDescription);
                        dialog.find("div[field-id=description] rich-editor").html(data.stepDescriptionRendered);
                    }

                    if (data.affectVersion) {
                        data.affectVersion.forEach(function(element) {
                            AJS.$('select[id="versions"] option').each(function() {
                                //If the name of version is the same then we choose it.
                                //this is only using names because identical versions in differents projects have not the same ID

                                if (jQuery.trim($(this).text()) == jQuery.trim(element.label)) {
                                    AJS.$('select[id="versions"]').trigger('selectOption', [{ value: $(this).val(), title: element.label, label: element.label }]);
                                }
                            });

                        }, this);
                    }

                    if (data.label) {
                        data.label.forEach(function(element) {
                            AJS.$('select[id="labels"]').trigger('selectOption', [{ value: element }]);
                        }, this);
                    }
                }
            }
        });
    }

    function deleteDefectFromGlobalExecution(el) {
        $('#content-panel').block();

        clearMessage();

        var path = contextPath + '/rest/raven/1.0/testrun/' + testRunId + '/defects/' + el[0].id;

        var value = el[0].textContent;

        $.ajax({
            type: "DELETE",
            url: path,
            processData: true,
            async: true,
            data: value,
            contentType: "application/json",
            error: function(qXHR, textStatus, errorThrown) {
                if (errorThrown && errorThrown.trim() != '') {
                    errorThrown = errorThrown + ': ' + qXHR.responseText;
                } else {
                    errorThrown = qXHR.responseText;
                }

                message(AJS.I18n.getText('execute-test-action.defects.delete.error'), errorThrown)
            },
            success: function(data, textStatus, jqXHR) {
                $(el).remove();

                refreshModule($('#execution-defects-module'), $('#global-defects-list'));

                checkDefectsSize();
                lcarousel.apply("defect", $("#global-defects-list"), LCAROUSELSIZE);
                refreshActivityStream();
            },
            complete: function() {
                $('#content-panel').unblock();
            }
        });
    }

    function processAddDefectResults(data) {
        // new defects
        if (data && data.length > 0) {
            $.each($(data), function(i, issue) {
                var defectContent = RAVEN.ExecuteTest.defectLink({
                    appId: issue.appId,
                    id: issue.id,
                    key: issue.key,
                    summary: issue.summary,
                    iconUrl: issue.iconUrl,
                    status: issue.status,
                    contextPath: AJS.contextPath(),
                    readonly: readonly,
                    issueURL: issue.url
                });
                var defectsList = $('#global-defects-list');
                defectsList.append(defectContent);
            });

            refreshModule($('#execution-defects-module'), $('#global-defects-list'));

            checkDefectsSize();
            lcarousel.apply("defect", $("#global-defects-list"), LCAROUSELSIZE);
            refreshActivityStream();
        }
    }

    function deleteAttachmentFromGlobalExecution(el) {
        $('#content-panel').block();

        clearMessage();

        var id = el.val();
        var path = contextPath + '/rest/raven/1.0/testrun/' + testRunId + '/attachment/' + id;

        $.ajax({
            type: "DELETE",
            url: path,
            processData: false,
            async: true,
            contentType: "application/json",
            error: function(qXHR, textStatus, errorThrown) {
                if (errorThrown && errorThrown.trim() != '') {
                    errorThrown = errorThrown + ': ' + qXHR.responseText;
                } else {
                    errorThrown = qXHR.responseText;
                }

                message(AJS.I18n.getText('execute-test-action.attachments.delete.error'), errorThrown)
            },
            success: function(data, textStatus, jqXHR) {
                $(el).remove();

                refreshModule($("#execution-attachments-module"), $('#global-execution-attachments'));
                checkEvidencesSize();
                lcarousel.apply("evidences", $("#global-execution-attachments"), LCAROUSELSIZE);
                refreshActivityStream();
            },
            complete: function() {
                $('#content-panel').unblock();
            }
        });
    }

    function refreshAttachmentsFromServer() {
        $('#content-panel').block();

        clearMessage();

        var path = contextPath + '/rest/raven/1.0/testrun/' + testRunId + '/attachment';

        $.ajax({
            type: "GET",
            url: path,
            processData: true,
            async: true,
            contentType: "application/json",
            error: function(qXHR, textStatus, errorThrown) {
                if (errorThrown && errorThrown.trim() != '') {
                    errorThrown = errorThrown + ': ' + qXHR.responseText;
                } else {
                    errorThrown = qXHR.responseText;
                }

                message(AJS.I18n.getText('execute-test-action.attachments.refresh.error'), errorThrown)
            },
            success: function(data, textStatus, jqXHR) {
                var context = $('#global-execution-attachments').parent();
                $('#global-execution-attachments').remove();
                var innerHtml = RAVEN.ExecuteTest.createAttachments({
                    attachments: data,
                    contextPath: AJS.contextPath(),
                    readonly: readonly
                });
                context.html(innerHtml);

                refreshModule($("#execution-attachments-module"), $('#global-execution-attachments'));
                checkEvidencesSize();
                lcarousel.apply("evidences", $("#global-execution-attachments"), LCAROUSELSIZE);
            },
            complete: function() {
                applyFancybox();
                $('#content-panel').unblock();
            }
        });
    }

    // Applies Fancybox to all supported formats
    function applyFancybox() {
        $(".item-attachments a").each(
            function(key, value) {
                if (imageRegex.test(value.href.toLowerCase())) {
                    $(value).fancybox(fancyboxDefaultOpts);
                }
            });
    }

    function deleteAttachmentConfirmationDialog(attachmentId, attachmentName, fnDeleteAttachment, options) {
        var dialog = new JIRA.FormDialog({
            id: 'delete-attachment-dialog-' + attachmentId,
            content: function(callback) {
                var innerHtml = RAVEN.Attachments.deleteAttachmentConfirmationDialog({
                    attachmentName: attachmentName
                });
                callback(innerHtml);
            },
            submitHandler: function(e) {
                fnDeleteAttachment(options);
                dialog.hide();
                e.preventDefault();
            },
            autoClose: true
        });

        dialog.show();
    }

    function updateTestStepResultStatus(row, status, status_id) {
        $('#content-panel').block();

        clearMessage();

        var stepResultId = row.model.id;
        var path = contextPath + '/rest/raven/1.0/testrun/' + testRunId + '/steps/' + stepResultId + '/status';

        $.ajax({
            type: "PUT",
            url: path,
            processData: true,
            data: status,
            async: true,
            contentType: "application/json",
            error: function(qXHR, textStatus, errorThrown) {
                if (errorThrown && errorThrown.trim() != '') {
                    errorThrown = errorThrown + ': ' + qXHR.responseText;
                } else {
                    errorThrown = qXHR.responseText;
                }

                message(AJS.I18n.getText('execute-test-action.status.check.error'), errorThrown)
            },
            success: function(data, textStatus, jqXHR) {
                // update backbone model
                row.model.set("status", status);
                row.model.set("status_id", status_id);
                row.render();

                updateTestRunStatusCallback(data.obj, false);
                displayWorkflowTransitionMessages(data.errors);
            },
            complete: function() {
                $('#content-panel').unblock();
            }
        });

    }

    function deleteDefectConfirmationDialog(key, fnDeleteEvidence, options) {
        var dialog = new JIRA.FormDialog({
            id: 'delete-attachment-dialog',
            content: function(callback) {
                var innerHtml = RAVEN.ExecuteTest.deleteDefectConfirmationDialog({
                    defectKey: options.key
                });
                callback(innerHtml);
            },
            submitHandler: function(e) {
                fnDeleteEvidence(options.$el);
                dialog.hide();
                e.preventDefault();
            },
            autoClose: true
        });

        dialog.show();
    }

    function resetConfirmationDialog() {
        var dialog = new JIRA.FormDialog({
            id: 'reset-test-dialog',
            trigger: '#reset-test-run',
            content: function(callback) {
                var title = AJS.I18n.getText('execute-test-action.reset.title');
                var message = AJS.I18n.getText('execute-test-action.reset.message');
                var innerHtml = RAVEN.Dialog.confirmationDialog({
                    title: title,
                    message: message,
                    severity: 'warning'
                });
                callback(innerHtml);
            },
            submitHandler: function(e) {
                dialog.hide();
                e.preventDefault();
                window.location = getResetTestHref();
            },
            autoClose: true
        });

        dialog.show();
    }

    function mergeConfirmationDialog() {
        var dialog = new JIRA.FormDialog({
            id: 'merge-test-dialog',
            trigger: '#merge-test-run',
            content: function(callback) {
                var title = AJS.I18n.getText('execute-test-action.merge.title');
                var message = AJS.I18n.getText('execute-test-action.merge.message');
                var innerHtml = RAVEN.Dialog.confirmationDialog({
                    title: title,
                    message: message,
                    severity: 'warning'
                });
                callback(innerHtml);
            },
            submitHandler: function(e) {
                dialog.hide();
                e.preventDefault();
                window.location = getMergeTestHref();
            },
            autoClose: true
        });

        dialog.show();
    }

    function getMergeTestHref() {
        var testExecKey = getTestExecKey();
        var testKey = getTestKey();
        var link = contextPath + '/secure/XrayExecuteTest!Merge.jspa?testExecIssueKey=' + testExecKey;
        link += '&testIssueKey=' + testKey;
        return link;
    }

    function getResetTestHref() {
        var testExecKey = getTestExecKey();
        var testKey = getTestKey();
        var link = contextPath + '/secure/XrayExecuteTest!Reset.jspa?testExecIssueKey=' + testExecKey;
        link += '&testIssueKey=' + testKey;
        return link;
    }

    function findExampleModel(exampleId) {
        return _.find(testExamplesResult, function(exampleResult) {
            return exampleResult.id == exampleId;
        });
    }

    function getResults(exampleId) {
        var exampleResultModel = findExampleModel(exampleId);
        var allSteps = [];

        if (exampleResultModel == null) {
            console.log("No Example Steps was found!");
            return [];
        }

        function addSteps(name, type) {
            var steps = getStepsByType(type);
            if (_.isArray(steps) && !_.isEmpty(steps)) {
                allSteps.push({
                    name: name,
                    data: steps
                });
            }
        }

        function getStepsByType(type) {
            if (exampleResultModel instanceof Backbone.Model) {
                return exampleResultModel.get(type);
            } else {
                return exampleResultModel[type];
            }
        }

        addSteps("Hooks", 'hooks');
        addSteps("Background", 'backgrounds');
        addSteps("Steps", 'steps');

        return allSteps;
    }

    function renderExamplesSection() {
        var ExampleModel = Backbone.Model.extend({
            urlRoot: function() {
                return contextPath + '/rest/raven/1.0/testrun/' + getTestRunId() + '/examples';
            },
            defaults: function() {
                return {
                    id: 0,
                    rank: 0,
                    values: [],
                    status: 'TODO',
                    duration: '',
                    backgrounds: [],
                    hooks: [],
                    steps: []
                }
            }
        });

        var ExamplesProgressBarModel = Backbone.Model.extend({
            urlRoot: function() {
                return contextPath + '/rest/raven/1.0/testrun/' + getTestRunId() + '/examples/status';
            },
            defaults: function() {
                return {
                    pass: 0,
                    fail: 0,
                    todo: 0
                }
            }
        });

        var ExampleCollection = Backbone.Collection.extend({
            model: ExampleModel,
            url: function() {
                return contextPath + '/rest/raven/1.0/testrun/' + getTestRunId() + '/examples';
            }
        });

        var ExamplesProgressBarView = Backbone.View.extend({
            el: $('#execution-examples-progressbar'),
            model: new ExamplesProgressBarModel(),

            initialize: function() {
                var self = this;

                self.$el.block();
                this.model.fetch({
                    success: function() {
                        self.render();
                        self.$el.unblock();
                    },
                    error: function(model, response) {
                        // do nothing - does not show the progress bar
                        self.$el.unblock();
                    }
                });
            },

            render: function() {
                this.$el.empty();

                var count = this.model.get('count');
                if (count > 0) {
                    var pass = this.model.get('pass');
                    var fail = this.model.get('fail');
                    var todo = this.model.get('todo');

                    var pbHtml = RAVEN.ExecuteTest.renderStatusProgressBar({
                        'pass': pass,
                        'fail': fail,
                        'todo': todo
                    });
                    this.$el.html(pbHtml);
                } else {
                    this.$el.css('min-height', 0);
                }

                return this;
            }
        });

        var ExamplesView = Backbone.View.extend({
            model: new ExampleCollection(),
            el: $('#execution-examples-table'),

            initialize: function() {
                var self = this;

                this.model.on('reset', this.render, this);

                $('#execution-examples-table').block();
                this.model.fetch({
                    success: function() {
                        self.render();
                        $('#execution-examples-table').unblock(); // unmask on complete was being unmasked before render
                    },
                    error: function(model, response) {
                        AJS.messages.error(self.$el, {
                            title: AJS.I18n.getText('execute-test-action.examples.error'),
                            body: response.responseText,
                            closeable: false
                        });
                        $('#execution-examples-table').unblock();
                    }
                });
            },

            render: function() {
                // clear view
                this.$el.empty();

                // empty table
                if (this.model.length == 0) {
                    AJS.messages.info(this.$el, {
                        body: AJS.I18n.getText('execute-test-action.examples.no-table'),
                        closeable: false
                    });
                } else {
                    var headerValues = _.first(this.model.toArray()).get('values');
                    testExamplesResult = this.model.toArray();
                    exampleValuesLength = headerValues.length + BASE_SPAN_VALUE;

                    // render table skeleton
                    var tableHtml = RAVEN.ExecuteTest.renderExampleTable({
                        values: headerValues
                    });
                    this.$el.html(tableHtml);

                    var $tbody = this.$el.find('tbody');

                    var rows = this.model.toArray().splice(1);
                    if (rows && rows.length > 0) {
                        _.each(rows, function(example, i) {
                            $tbody.append((new ExampleView({
                                model: example
                            })).render().$el);
                        });
                    } else {
                        // render empty row
                        $tbody.html('<tr><td colspan="3"><em>' + AJS.I18n.getText('execute-test-action.examples.empty') + '</em></td></tr>');
                    }
                }

                // render progress bar
                new ExamplesProgressBarView();

                return this;
            }
        });

        var ExampleView = Backbone.View.extend({
            tagName: 'tr',
            styleClass: 'example-row',
            carouselFixedSize: null,
            carouselMaxSize: 0,
            events: {
                'click .raven-dropdown-trigger': 'dropdownTrigger',
                'click .toogle-examples-steps': 'toggleExpandExampleStepsRow'
            },
            initialize: function() {
                this.render();
            },

            render: function() {
                this.$el.empty();

                var status = this.model.get('status');
                var hasSteps = this.model.get('steps').length > 0;

                // render table skeleton
                var rowHtml = RAVEN.ExecuteTest.renderExampleRowCells({
                    'id': this.model.get('id'),
                    'hasSteps': hasSteps,
                    'values': this.model.get('values'),
                    'status': status,
                    'duration': this.model.get('duration'),
                    'statusStyle': status.toLowerCase(),
                    'statusTitle': this.model.get('statusDescription'),
                    'statusEditable': !hasSteps && isExamplesEditable && !readonly
                });

                this.$el.html(rowHtml);

                return this;
            },

            dropdownTrigger: function(e) {
                currentExampleView = this;
            },

            toggleExpandExampleStepsRow: function(e) {
                if ($(e.target).hasClass('enabled')) {
                    $(e.target).removeClass('enabled').addClass('disabled');
                    this.$el.next('.example-steps-rows').hide();
                } else {
                    $(e.target).removeClass('disabled').addClass('enabled');
                    var $row = this.renderExampleSteps($(e.target).attr('id'));
                    $row.show();
                }
            },

            renderExampleSteps: function(exampleId) {
                var steps = getResults(exampleId);

                var $stepsRow = this.$el.next('.example-steps-rows');
                if ($stepsRow.length === 0) {
                    if (steps && steps.length > 0) {
                        $stepsRow = $(RAVEN.ExecuteTest.renderExampleStepsTable({
                            'testExec': $('#test-exec-key').val(),
                            'context': AJS.contextPath(),
                            'isScenarioOutlineTest': isScenarioOutlineTest,
                            'results': steps,
                            'spanColumns': exampleValuesLength,
                            'spanValueColumns': (exampleValuesLength - BASE_SPAN_VALUE),
                            'requireExperimentalDialog2': requireExperimentalDialog2
                        }));

                        $stepsRow.insertAfter(this.$el);

                        steps.forEach(function(allSteps) {
                             allSteps.data.forEach(function(sectionStep) {
                                initializeStepAttachmentsList(sectionStep.id);
                             });
                        });
                    }
                }

                return $stepsRow;
            }
        });

        // set status accelerator click handler
        $(document).on('click.raven', '#raven-example-status-acc .raven-status-acc-option', function(e) {
            if (currentExampleView) {
                var view = currentExampleView;

                var status = $(this).data('status');
                var modelStatus = view.model.get('status');

                if (modelStatus !== status) {
                    $('#execution-examples-table').block();
                    view.model.save({
                        'status': status
                    }, {
                        success: function(model, response) {
                            view.render();
                            $('#execution-examples-table').unblock();
                            updateTestRunStatusFromServer();
                            new ExamplesProgressBarView();
                            testRunStatusView.initialize();
                            refreshActivityStream();
                        },
                        error: function() {
                            $('#execution-examples-table').unblock();
                        }
                    });
                }
            }

            e.preventDefault();
            e.stopPropagation();
        });

        // clear current dropdown trigger
        $(document).on('aui-dropdown2-hide', '#raven-example-status-acc', function(event) {
            // dropdown2 bug - the menu def is moved next to the trigger
            var version = $('body').data('version');

            if (!version || version.toString().charAt(0) === '5') {
                var clone = $("#raven-example-status-acc").clone().hide();
                $('.execute-test-header').append(clone);
            }

            //currentExampleView = null;
        });

        // render and return view
        return new ExamplesView();
    }

    function renderResultsSection() {

        var ResultModel = Backbone.Model.extend({
            urlRoot: function() {
                return contextPath + '/rest/raven/1.0/testrun/' + getTestRunId() + '/results';
            },
            defaults: function() {
                return {
                    rank: 0,
                    values: [],
                    status: 'TODO'
                }
            }
        });

        var ResultsProgressBarModel = Backbone.Model.extend({
            urlRoot: function() {
                return contextPath + '/rest/raven/1.0/testrun/' + getTestRunId() + '/results/status';
            },
            defaults: function() {
                return {
                    pass: 0,
                    fail: 0,
                    todo: 0
                }
            }
        });

        var ResultCollection = Backbone.Collection.extend({
            model: ResultModel,
            url: function() {
                return contextPath + '/rest/raven/1.0/testrun/' + getTestRunId() + '/results';
            }
        });

        // VIEWS

        var ResultsProgressBarView = Backbone.View.extend({
            el: $('#execution-results-progressbar'),
            model: new ResultsProgressBarModel(),

            initialize: function() {
                var self = this;

                self.$el.block();
                this.model.fetch({
                    success: function() {
                        self.render();
                        self.$el.unblock();
                    },
                    error: function(model, response) {
                        // do nothing - does not show the progress bar
                        self.$el.unblock();
                    }
                });
            },

            render: function() {
                this.$el.empty();

                var count = this.model.get('count');
                if (count > 0) {
                    var pass = this.model.get('pass');
                    var fail = this.model.get('fail');
                    var todo = this.model.get('todo');

                    var pbHtml = RAVEN.ExecuteTest.renderStatusProgressBar({
                        'pass': pass,
                        'fail': fail,
                        'todo': todo
                    });
                    this.$el.html(pbHtml);
                } else {
                    this.$el.css('min-height', 0);
                }

                return this;
            }
        });

        function showColumnErrorMessage() {
            return (isCucumberTest == 'false' || isCucumberInViewCompatibilityMode == 'true');
        }

        var ResultsView = Backbone.View.extend({
            model: new ResultCollection(),
            el: $('#execution-results-table'),

            initialize: function() {
                var self = this;
                this.model.on('reset', this.render, this);

                $('#execution-results-table').block();
                this.model.fetch({
                    success: function() {
                        self.render();
                        $('#execution-results-table').unblock(); // unmask on complete was being unmasked before render
                    },
                    error: function(model, response) {
                        AJS.messages.error(self.$el, {
                            title: AJS.I18n.getText('execute-test-action.results.error'),
                            body: response.responseText,
                            closeable: false
                        });
                        $('#execution-results-table').unblock();
                    }
                });

                this.toggleResultsExampleSteps();
            },

            render: function() {
                // clear view
                this.$el.empty();

                // render table skeleton
                var tableHtml = RAVEN.ExecuteTest.renderResultsTable({
                    'showErrorMessage': showColumnErrorMessage()
                });
                this.$el.html(tableHtml);

                var $tbody = this.$el.find('tbody');

                var rows = this.model.toArray();
                if (rows && rows.length > 0) {
                    _.each(rows, function(result, i) {
                        $tbody.append((new ResultView({
                            model: result
                        })).render().$el);
                    });
                } else {
                    $('#execution-results-module').hide();
                    return;
                }

                // render progress bar
                new ResultsProgressBarView();

                return this;
            },

            dispose: function() {
                // clear view
                this.$el.empty();
            },

            toggleResultsExampleSteps: function() {
                $(document).on('click', '.toogle-examples-steps', function(e) {

                    var closestTR = $(e.target).closest('tr');

                    if ($(e.target).hasClass('enabled')) {
                        $(e.target).removeClass('enabled').addClass('disabled');
                        closestTR.next('.example-steps-rows').hide();

                    } else {
                        $(e.target).removeClass('disabled').addClass('enabled');

                        var steps = getResults($(e.target).attr('id'));

                        var $stepsRow = closestTR.next('.example-steps-rows');

                        if ($stepsRow.length === 0) {
                            if (steps && steps.length > 0) {
                                $stepsRow = $(RAVEN.ExecuteTest.renderExampleStepsTable({
                                    'testExec': $('#test-exec-key').val(),
                                    'context': AJS.contextPath(),
                                    'isScenarioOutlineTest': isScenarioOutlineTest,
                                    'results': steps,
                                    'spanColumns': exampleValuesLength,
                                    'spanValueColumns': (exampleValuesLength - BASE_SPAN_VALUE),
                                    'requireExperimentalDialog2': requireExperimentalDialog2
                                }));

                                $stepsRow.insertAfter(closestTR);

                                steps.forEach(function(allSteps) {
                                    allSteps.data.forEach(function(sectionStep) {
                                        initializeStepAttachmentsList(sectionStep.id);
                                    });
                                });
                            }
                        }

                        $stepsRow.show();
                    }
                });
            }
        });

        var ResultView = Backbone.View.extend({
            tagName: 'tr',
            styleClass: 'result-row',
            events: {
                'click .toogle-result-examples': 'toggleExpandExamplesRow'
            },
            initialize: function() {
                this.render();
            },

            render: function() {
                this.$el.empty();

                var status = this.model.get('status');
                var examples = this.model.get('examples');
                var log = this.model.get('log');

                // render table skeleton
                var rowHtml = RAVEN.ExecuteTest.renderResultRow({
                    'showErrorMessage': showColumnErrorMessage(),
                    'context': this.model.get('context'),
                    'log': log == null || log.length == 0 ? null : log,
                    'duration': this.model.get('duration'),
                    'status': status,
                    'statusStyle': status.toLowerCase(),
                    'statusTitle': this.model.get('statusDescription'),
                    'containsExamples': examples && examples.length > 0
                });

                this.$el.html(rowHtml);

                return this;
            },

            toggleExpandExamplesRow: function(e) {
                if ($(e.target).hasClass('enabled')) {
                    // This row is already open - close it
                    $(e.target).removeClass('enabled').addClass('disabled');
                    this.$el.next('.result-examples-row').hide();
                } else {
                    // Open this row
                    $(e.target).removeClass('disabled').addClass('enabled');
                    var $row = this.renderResultExamples();

                    $row.show();
                }
            },

            renderResultExamples: function() {
                // render result examples
                var examples = this.model.get('examples');

                var $examplesRow = this.$el.next('.result-examples-row');
                if ($examplesRow.length === 0) {
                    if (examples && examples.length > 0) {
                        var names = _.first(examples).values;
                        var values = examples.splice(1);

                        exampleValuesLength = names.length + BASE_SPAN_VALUE;
                        if (isScenarioOutlineTest === 'true') {
                            testExamplesResult = values;
                        } else {
                            testExamplesResult = examples;
                        }

                        // append style property
                        $.each(values, function() {
                            this.statusStyle = this.status.toLowerCase();
                        });

                        var spanColumns = 6;
                        var spanValueColumns = 3;
                        var steps = getResults(_.first(examples).id);

                        $examplesRow = $(RAVEN.ExecuteTest.renderResultExamplesRow({
                            'testExec': $('#test-exec-key').val(),
                            'context': AJS.contextPath(),
                            'names': names,
                            'examples': values,
                            'isScenarioOutline': isScenarioOutlineTest,
                            'results': steps,
                            'spanColumns': spanColumns,
                            'spanValueColumns': spanValueColumns,
                            'requireExperimentalDialog2': requireExperimentalDialog2
                        }));

                        $examplesRow.insertAfter(this.$el);

                        if (steps && steps.length > 0) {
                            steps.forEach(function (allSteps) {
                                allSteps.data.forEach(function (sectionStep) {
                                    initializeStepAttachmentsList(sectionStep.id);
                                });
                            });
                        }
                    }
                }

                return $examplesRow;
            }
        });

        // render and return view
        return new ResultsView();
    }

    function refreshModule($ele, $list) {
        var sizeEle = $ele.find(".mod-title .size");
        var size = $list.find("li").length;
        sizeEle.html("(" + size + ")");
    }

    function refreshActivityStream() {
        if (activityStreamView) {
            if (activityStreamView.isViewExpanded()) {
                activityStreamView.refresh();
            }
        }
    }

    function canEditTestRunDates() {
        return ($("#can-edit-test-run-dates").val() == "true" && $("#test-run-readonly").val() == "false");
    }

    function setWithDateEditionMode() {
        if (canEditTestRunDates() == true) {
            initDatePickers();
            /*Finished On edition mode - remove line bellow to activate*/
            /*$("#TestExecutionDetails-to-dateTime-trigger").css("display", "none");*/
        } else {
            $("#TestExecutionDetails-from-dateTime-trigger").css("display", "none");
            /*Finished On edition mode - uncomment block bellow to activate*/
            /*$("#TestExecutionDetails-to-dateTime-trigger").css("display", "none");*/
        }
    }

    function getTimeFormat() {
        return $("#time-12or24").val();
    }

    function getDateTimeFormat() {
        return $("#jira-datetime-picker-format").val();
    }

    function initDatePickers() {
        Calendar.setup({
            firstDay: 1,
            inputField: 'test-exec-start-input',
            button: 'TestExecutionDetails-from-dateTime-trigger',
            singleClick: true,
            showsTime: true,
            useISO8601WeekNumbers: false,
            timeFormat: getTimeFormat(),
            ifFormat: getDateTimeFormat(),
            /*to prevent unnecessary rest calls we'll use onClose event instead of onUpdate*/
            onClose: function(e) {
                clearMessage();
                var date = e.date.getFullYear() + "," + e.date.getMonth() + "," + e.date.getDate() + "," + e.date.getHours() + "," + e.date.getMinutes();
                $("#testrun-startedon-spinnerwrapper").block;
                $("#testrun-startedon-spinnerwrapper").spin("small");
                $.ajax({
                    type: "PUT",
                    url: contextPath + '/rest/raven/1.0/testrun/' + testRunId + "/startedon",
                    processData: true,
                    async: true,
                    data: date,
                    contentType: "application/json",
                    error: function(qXHR, textStatus, errorThrown) {
                        if (errorThrown && errorThrown.trim() != '') {
                            errorThrown = errorThrown + ': ' + qXHR.responseText;
                        } else {
                            errorThrown = qXHR.responseText;
                        }
                        message(AJS.I18n.getText('execute-test-action.testrun-date-startedon-update-error'), errorThrown);
                        $("#test-exec-start").show();
                        $("#test-exec-start-input").hide();
                        $("#test-exec-start-input").val($("#backup-startDate").val());
                        $("#testrun-startedon-spinnerwrapper").block;
                        $("#testrun-startedon-spinnerwrapper").spinStop();
                        e.hide();
                    },
                    success: function(data, textStatus, jqXHR) {
                        $("#test-exec-start").show();
                        $("#test-exec-start").html("<strong>" + data + "</strong>");
                        $("#test-exec-start-input").hide();
                        $("#backup-startDate").val(data);
                        $("#testrun-startedon-spinnerwrapper").block;
                        $("#testrun-startedon-spinnerwrapper").spinStop();
                        e.hide();
                        refreshActivityStream();
                    }
                });
            }
        });

        /*Finished On edition mode - uncomment block bellow to activate*/
        /*Calendar.setup({
            firstDay: 1,
            inputField: 'test-exec-finish-input',
            button: 'TestExecutionDetails-to-dateTime-trigger',
            singleClick: true,
            showsTime: true,
            useISO8601WeekNumbers: false,
            timeFormat: getTimeFormat(),
            ifFormat: getDateTimeFormat(),
            /!*to prevent unnecessary rest calls we'll use onClose event instead of onUpdate*!/
            onClose: function(e) {
                clearMessage();
                var date = e.date.getFullYear() + "," + e.date.getMonth() + "," + e.date.getDate() + "," + e.date.getHours() + "," + e.date.getMinutes();
                $("#testrun-finishedon-spinnerwrapper").block;
                $("#testrun-finishedon-spinnerwrapper").spin("small");
                $.ajax({
                    type: "PUT",
                    url: contextPath + '/rest/raven/1.0/testrun/' + testRunId + "/finishedon",
                    processData: true,
                    async: true,
                    data: date,
                    contentType: "application/json",
                    error: function(qXHR, textStatus, errorThrown) {
                        if (errorThrown && errorThrown.trim() != '') {
                            errorThrown = errorThrown + ': ' + qXHR.responseText;
                        } else {
                            errorThrown = qXHR.responseText;
                        }
                        message(AJS.I18n.getText('execute-test-action.testrun-date-finishedon-update-error'), errorThrown);
                        $("#test-exec-finish").show();
                        $("#test-exec-finish-input").hide();
                        $("#test-exec-finish-input").val($("#backup-finishedDate").val());
                        $("#testrun-finishedon-spinnerwrapper").block;
                        $("#testrun-finishedon-spinnerwrapper").spinStop();
                        e.hide();
                    },
                    success: function(data, textStatus, jqXHR) {
                        $("#test-exec-finish").show();
                        $("#test-exec-finish").html("<strong>" + data + "</strong>");
                        $("#test-exec-finish-input").hide();
                        $("#backup-finishedDate").val(data);
                        $("#testrun-finishedon-spinnerwrapper").block;
                        $("#testrun-finishedon-spinnerwrapper").spinStop();
                        e.hide();
                        refreshActivityStream();
                    }
                });
            }
        });*/

    }

    // DOM READY
    $(document).ready(function() {

        if($("#should-clean-events").val() === "true"){
            //removing nosy event handlers, check issue XRAY-2392
            $(document).off("QuickCreateIssue.issueCreated");
        }

        AJS.messages.setup();
        lcarousel = RAVEN.Component.LCarousel;

        // fix header breadcrumbs
        var isGreaterThanOrEqualToJira6 = JIRA.Version.isGreaterThanOrEqualTo('6.0');
        if (!isGreaterThanOrEqualToJira6) {
            $('.execute-test-header').addClass('old-jira');
        }

        readonly = $("#test-run-readonly").val() == 'true';
        testRunId = $("#test-run-id").val();
        isManualTest = $("#manual-test").val();
        isGenericTest = $("#generic-test").val();
        isCucumberTest = $("#cucumber-test").val();
        isCucumberTest = $("#cucumber-test").val();
        isCucumberInViewCompatibilityMode = $("#view-compatibility-mode").val();
        isScenarioOutlineTest = $("#scenario-outline-test").val();
        hasMultipleResults = $("#has-multiple-results").val();
        canSetRequirementStatus = $("#can-set-requirement-status").val();
        requireExperimentalDialog2 = $("#require-experimental-dialog").val() == 'true';
        isExamplesEditable = $("#scenario-outline-examples-editable").val() == 'true';
        issueTypeDefect = ($('#defectIssueType').val().length > 0) ? parseInt($('#defectIssueType').val()) : 1;

        assigneeField = new RAVEN.InlineEdit.AssigneePickerField(
            $('#test-exec-user-field')
        );


        $(document).on("submit", "#test-exec-user-field form", function(e) {
            assigneeField.save();
            e.preventDefault();
            e.stopPropagation();
        });

        if (!$('body').hasClass('aui-sidebar-collapsed')) {
            $('#execution-comment-module-heading').height(46);
            $('#execution-defects-module-heading').height(46);
            $('#execution-attachments-module-heading').height(46);
        }

        $(document).on("click", ".aui-sidebar-toggle", function(e) {
            if ($('body').hasClass('aui-sidebar-collapsed')) {
                $('#execution-comment-module-heading').height(24);
                $('#execution-defects-module-heading').height(24);
                $('#execution-attachments-module-heading').height(24);
            } else {
                $('#execution-comment-module-heading').height(46);
                $('#execution-defects-module-heading').height(46);
                $('#execution-attachments-module-heading').height(46);
            }
        });


        checkDefectsSize();
        lcarousel.apply("defect", $("#global-defects-list"), LCAROUSELSIZE);
        checkEvidencesSize();
        lcarousel.apply("evidences", $("#global-execution-attachments"), LCAROUSELSIZE);

        // creates the create defect issue dialog
        if (JIRA.Forms && JIRA.Forms.createCreateIssueForm) {
            createForm = JIRA.Forms.createCreateIssueForm({
                issueType: issueTypeDefect
            });

            // select trigger for create issue in global context
            var createIssueDialogGlobalContext = createForm.asDialog({
                trigger: $('#raven-create-issue-link-global-context'),
                id: 'create-issue-dialog'
            });

            createIssueDialogGlobalContext.bind('Dialog.show', function(e, data, d2) {
                createIssueDialogGlobalContext.get$popup().addClass('raven-create-defect-dialog');
            });

            createForm2 = JIRA.Forms.createCreateIssueForm({
                issueType: issueTypeDefect
            });

            // select trigger for create issue in global context
            var createIssueDialogGlobalContextDropDown = createForm2.asDialog({
                trigger: $('.aui-dropdown2 #raven-create-issue-link-global-context'),
                id: 'create-issue-dialog'
            });

            createIssueDialogGlobalContextDropDown.bind('Dialog.show', function(e, data, d2) {
                createIssueDialogGlobalContextDropDown.get$popup().addClass('raven-create-defect-dialog');
            });

            JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function(e, context, reason) {
                var dialog = $('#create-issue-dialog.raven-create-defect-dialog.jira-dialog-open, #create-issue-dialog.raven-create-defect-dialog.aui-dialog-open');
                if (dialog.length > 0) {
                    if (currentDefectPicker) {
                        var $row = currentDefectPicker.$container.closest('tr');
                        var row = testStepsTable.getRowFromElement($row);

                        getDefectFieldsDefaults(dialog, row.model.id);
                    } else {
                        getDefectFieldsDefaults(dialog, null);
                    }
                }
            });

            createIssueDialogGlobalContext.bind('Dialog.show', function(e, data, d2) {
                isGlobalCreateDefect = true;
            });

            createIssueDialogGlobalContext.bind('Dialog.hide', function(e) {
                isGlobalCreateDefect = false;
            });

            createIssueDialogGlobalContextDropDown.bind('Dialog.show', function(e, data, d2) {
                isGlobalCreateDefect = true;
            });

            createIssueDialogGlobalContextDropDown.bind('Dialog.hide', function(e) {
                isGlobalCreateDefect = false;
            });
        }

        JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function(e, context, reason) {
            var dialog = $('#create-subtask-dialog.jira-dialog-open, #create-subtask-dialog.aui-dialog-open');
            if (dialog.length > 0) {
                if (currentDefectPicker) {
                    var $row = currentDefectPicker.$container.closest('tr');
                    var row = testStepsTable.getRowFromElement($row);

                    getDefectFieldsDefaults(dialog, row.model.id);
                } else {
                    getDefectFieldsDefaults(dialog, null);
                }
            }
        });

        var attachDialog = new JIRA.FormDialog({
            id: "raven-attach-file-dialog",
            trigger: "#add-attachments-link",
            ajaxOptions: JIRA.Dialogs.getDefaultAjaxOptions,
            issueMsg: 'thanks_issue_attached',
            onSuccessfulSubmit: function() {
                refreshAttachmentsFromServer();
                refreshActivityStream();
            },
            onContentRefresh: function() {
                jQuery(".overflow-ellipsis").textOverflow();
            },
            onDialogFinished: function() {},
            autoClose: true
        });

        var IMPORTRESULTS = window.IMPORTRESULTS || {};
        IMPORTRESULTS.FormDialog = JIRA.FormDialog.extend({
            _getFormDataAsObject: function() {
                var data = new FormData(this.$form[0]);
                data.append('inline', true);
                data.append('decorator', 'dialog');
                return data;
            }
        });

        JIRA.Dialogs.uploadFile = new IMPORTRESULTS.FormDialog({
            id: "raven-import-exec-results-within-execution-dialog",
            trigger: "#import-results-to-cucumber",
            ajaxOptions: JIRA.Dialogs.getDefaultAjaxOptions,
            onSuccessfulSubmit: function() {},
            submitAjaxOptions: {
                type: "post",
                data: {
                    inline: true,
                    decorator: "dialog"
                },
                processData: false,
                contentType: false,
                mimeType: 'multipart/form-data',
                dataType: "html"
            }
        });

        $('#testrun-status-action').on('testrun-status-update', function(e, content) {
            var obj = content.data.obj;
            var errors = content.data.errors;
            var refreshSteps = content.refreshSteps;

            updateTestRunStatusCallback(obj, refreshSteps);
            refreshActivityStream();
            if (errors != null) {
                displayWorkflowTransitionMessages(errors);
            }
        });


        $(document).on('click.raven', '#test-execution-status-field-new .raven-status-acc-option', function(e) {

            // New Status Id
            var data = $(this).attr("value");

            $.ajax({
                type: "PUT",
                url: contextPath + '/rest/raven/1.0/testrun/' + testRunId + "/status",
                processData: true,
                async: true,
                data: data,
                contentType: "application/json",
                error: function(qXHR, textStatus, errorThrown) {
                    if (errorThrown && errorThrown.trim() != '') {
                        errorThrown = errorThrown + ': ' + qXHR.responseText;
                    } else {
                        errorThrown = qXHR.responseText;
                    }

                    message(AJS.I18n.getText('execute-test-action.status.check.error'), errorThrown)
                },
                success: function(data, textStatus, jqXHR) {
                    updateTestRunStatusCallback(data.obj, true);
                    displayWorkflowTransitionMessages(data.errors);
                }
            });
        });

        var commentsField = new RAVEN.InlineEdit.WikiTextField(
            $('#execution-comment-field'), {
                success: function(data) {
                    if (data.raw !== "") {
                        $("#review-comment").css("visibility", "visible");
                    } else {
                        $("#review-comment").css("visibility", "hidden");
                    }
                    $(".testRun-comment").html(data.rendered);
                    refreshActivityStream();
                },
                error: function(field, error) {
                    message(AJS.I18n.getText('execute-test-action.comment.update.error'), error);
                }
            }
        );

        var inlineEdit = new RAVEN.InlineEdit();

        if (hasMultipleResults === 'false') {
            // Render Examples section
            examplesView = renderExamplesSection();
        } else {
            // Render Results section
            resultsView = renderResultsSection();
        }

        if (canSetRequirementStatus === 'true') {
            requirementStatusView = new RAVEN.ExecuteTest.RequirementStatusesView({ 'isStatusEditable': !readonly && $('#is-final-status').val() === 'true', 'activityStreamView': activityStreamView });
        }

        // add defects button click handler
        $(document).on('click.raven', '#raven-add-defects-global-context', function() {
            clearMessage();

            new RAVEN.Dialogs.createIssueSelectorDialog('DEFAULT', null, null, getTestExecKey(), null, function(issues) {
                if (issues && issues.length > 0) {
                    addDefectsToGlobalExecution(issues);
                }
            }, null, getApplicationLinks());
        });

        // add defects button click handler
        $(document).on('click.raven', '#raven-add-defects-step-context', function() {
            clearMessage();

            new RAVEN.Dialogs.createIssueSelectorDialog('DEFAULT', null, null, getTestExecKey(), null, null, null, getApplicationLinks());
        });

        // delete defects icon click handler
        $(document).on('click.raven', '#global-defects-list li .remove-command', function(e) {
            var self = this;

            var el = $(e.target).closest('li');

            var options = {};
            options.$el = el;
            options.key = el[0].id;

            deleteDefectConfirmationDialog(key, deleteDefectFromGlobalExecution, options);

            e.preventDefault();
            e.stopPropagation();

        });

        // delete attachments icon click handler
        $(document).on('click.raven', '#global-execution-attachments li .remove-command', function(e) {
            var el = $(e.target).closest('li');
            var id = el.val();
            var fileName = el.data('name');

            deleteAttachmentConfirmationDialog(id, fileName, deleteAttachmentFromGlobalExecution, el)
        });

        // set status accelerator click handler
        $(document).on('click.raven', '#raven-status-acc .raven-status-acc-option', function(e) {
            var status = $(this).data('status');
            var statusId = $(this).data('status-id');

            var row = testStepsTable.getRowFromElement(currentDropdownTrigger.closest('tr'));

            var modelStatus = row.model.get("status");

            if (modelStatus !== status) {
                updateTestStepResultStatus(row, status, statusId);
            }

            e.preventDefault();
            e.stopPropagation();
        });

        // save current dropdown trigger
        $(document).on('click.raven', '.raven-dropdown-trigger', function(e) {
            currentDropdownTrigger = $(this);
        });

        // clear current dropdown trigger
        $(document).on('aui-dropdown2-hide', '#raven-status-acc', function(event) {
            // dropdown2 bug - the menu def is moved next to the trigger
            var version = $('body').data('version');

            if (!version || version.toString().charAt(0) === '5') {
                var clone = $("#raven-status-acc").clone().hide();
                $('.execute-test-header').append(clone);
            }
            //currentDropdownTrigger = null;
        });

        // bind AJS create issue event
        $(AJS).bind("QuickCreateIssue.issueCreated", function(event, issueData) {
            if (isGlobalCreateDefect === true) {
                addDefectsToGlobalExecution([issueData.issueKey]);
                event.stopImmediatePropagation();
            } else if (currentDefectPicker) {
                var item = new AJS.ItemDescriptor({
                    value: issueData.issueKey,
                    label: issueData.issueKey + " - " + issueData.summary,
                    icon: null,
                });

                currentDefectPicker.addItem(item);
                event.stopImmediatePropagation();
            }

        });

        // bind AJS create sub-task event
        $(AJS).bind("QuickCreateSubtask.sessionComplete", function(e, issues) {
            var issue = issues[0];
            if (isGlobalCreateDefect) {
                addDefectsToGlobalExecution([issue.issueKey]);

                require('aui/flag')({
                    type: 'success',
                    body: AJS.I18n.getText('execute-test-action.create-subtask-dialog.success', contextPath, issue.issueKey, issue.summary),
                    close: 'auto'
                });
            }

            isGlobalCreateDefect = false;
        });

        // stop propagation because of selection
        $(document).on('click.raven', '#reset-test-run', function(e) {
            resetConfirmationDialog();
            e.preventDefault();
            e.stopPropagation();
        });

        // stop propagation because of selection
        $(document).on('click.raven', '#merge-test-run', function(e) {
            mergeConfirmationDialog();
            e.preventDefault();
            e.stopPropagation();
        });

        // stop propagation because of selection
        $(document).on('click.raven.createissue', 'a.raven-create-issue-link', function(e) {
            e.stopPropagation();
        });

        $(document).on('click.raven.createsubtaskissue', 'a.raven-create-subtask-issue-link', function(e) {
            e.stopPropagation();
        });

        // stop propagation because of selection
        $(document).on('click.raven.createissue.global.context', '#raven-create-issue-link-global-context', function(e) {
            e.stopPropagation();
        });

        // stop propagation because of selection
        $(document).on('click.raven.createsubtask.global.context', '#raven-create-subtask-link-global-context', function(e) {
            e.preventDefault();
            e.stopPropagation();
            clearMessage();

            isGlobalCreateDefect = true;

            new RAVEN.Dialogs.createParentIssueSelectorDialog('DEFAULT', null, getTestExecKey(), null, null, null, null, getApplicationLinks(), null);
        });

        $(document).on('click.raven.createsubtask.global.context', '#raven-parent-issue-selector-dialog .cancel', function(e) {
            isGlobalCreateDefect = false;
        });

        $(document).on('click.raven.createsubtask.global.context', '#create-subtask-dialog .cancel', function(e) {
            isGlobalCreateDefect = false;
        });

        $(document).on('click.raven', '.aui-icon.aui-icon-small.aui-iconfont-collapsed', function(e) {
            var ulElem = $(e.target).closest('ul');
            ulElem.find('.aui-icon.aui-icon-small.aui-iconfont-expanded').show();
            ulElem.find('#execute-precondition-key-expanded').show();
            ulElem.find('#execute-precondition-summary-expanded').show();
            ulElem.find('#execute-precondition-condition-expanded').show();
            ulElem.find('#execute-precondition-key-collapsed').hide();
        });

        $(document).on('click.raven', '.aui-icon.aui-icon-small.aui-iconfont-expanded', function(e) {
            var ulElem = $(e.target).closest('ul');
            ulElem.find('.aui-icon.aui-icon-small.aui-iconfont-expanded').hide();
            ulElem.find('#execute-precondition-key-expanded').hide();
            ulElem.find('#execute-precondition-summary-expanded').hide();
            ulElem.find('#execute-precondition-condition-expanded').hide();
            ulElem.find('#execute-precondition-key-collapsed').show();
        });

        // Init activity stream handler
        $('#execution-activity-module .toggle.hide').on('click', function() {
            if (!activityStreamView) {
                activityStreamView = new RAVEN.ExecuteTest.ActivityStreamView({ 'testRunId': testRunId });
            } else {
                // the timeout will allow the default click events to execute before checking the status of the module
                setTimeout(function() {
                    activityStreamView.refresh();
                }, 100);
            }
        });

        $("div.mod-header a.toggle").on('click', function(e) {
            var ele = $(e.target);
            var modContent = ele.closest('div.module').find("div.mod-content");

            if (ele.hasClass("hide")) {
                ele.removeClass("hide");
                modContent.removeClass("hidden");
            } else {
                ele.addClass("hide");
                modContent.addClass("hidden");
            }
        });

        if (readonly === true) {
            info(null, AJS.I18n.getText('execute-test-action.message.readonly'));
        }

        // inform user if the test has changed since it started executing
        if (hasChanges() === true && isValidScenarioOutline()) {
            if (readonly === true) {
                info(null, AJS.I18n.getText('execute-test-action.modified-test-definition.readonly'));
            } else {
                var buttonResetHtml = '<span class="reset-button"><a class="aui-button" id="reset-test-run" href="#">' + AJS.I18n.getText('common.action.reset') + '</a></span>';

                //if test type has changed we can only reset the execution
                if (!hasChangedTestType()) {
                    var buttonMergeHtml = '<span class="reset-button"><a class="aui-button" id="merge-test-run" href="#">' + AJS.I18n.getText('common.action.merge') + '</a></span>';
                    info(null, AJS.I18n.getText('execute-test-action.modified-test-definition') + '<br/>' + buttonResetHtml + " " + buttonMergeHtml);
                } else {
                    info(null, AJS.I18n.getText('execute-test-action.modified-test-definition-only-reset') + '<br/>' + buttonResetHtml);
                }
            }
        }

        testRunStatusView = new RAVEN.ExecuteTest.StatusView({
            "el": "#testrun-status-action"
        });

        if (isManualTest === 'true') {

            testStepView = new RAVEN.ExecuteTest.TestStepView({
                "allowEdit": !readonly,
                "testRunStatusView": testRunStatusView
            });

            $(document).bind("test-step-refresh-activity", refreshActivityStream);
        }

        initializeAceEditorComponent();
        initializePreconditionsAttachmentsList();

        $("#dismiss-tip-msg").click(function() {
            $("#attach-tip-msg").hide();
            $("#raven-notifications-icon").show();
            $.ajax({
                type: "POST",
                url: contextPath + "/rest/raven/1.0/testrun/disableAttachScreenshotTip"
            });
        });

        if ($("#attach-tip-value").val() != "disabled") {
            $("#raven-notifications-icon").hide();
        }

        $("#test-exec-start-input").hide();
        $(document).on("click", "#TestExecutionDetails-from-dateTime-trigger", function(e) {
            $("#test-exec-start").hide();
            $("#test-exec-start-input").show();
        });

        /*Finished On edition mode - uncomment block bellow to activate*/
        /*$("#test-exec-finish-input").hide();
        $(document).on("click", "#TestExecutionDetails-to-dateTime-trigger", function(e) {
            $("#test-exec-finish").hide();
            $("#test-exec-finish-input").show();
        });*/

        setWithDateEditionMode();

    });

})(AJS.$);