(function($) {

    var disallowedTestExecStatuses = null;
    var disallowedTestStatuses = null;
    var allowedRoles = null;

    function formSubmitListener() {
        prepareTestDisalowedStatuses();
        prepareTestExecutionDisalowedStatuses();
        prepareRepositoryAlowedRoles();
        prepareAddXrayIssueTypeGroups();
        return true;
    }

    function prepareTestDisalowedStatuses() {
        var ids = $('#disallow-execution-test-statuses option:selected').map(function() {
            return $(this).data('id');
        }).get();

        $('#disallow-execution-test-status-ids').val(JSON.stringify(ids));
    }

    function prepareTestExecutionDisalowedStatuses() {
        var ids = $('#disallow-execution-statuses option:selected').map(function() {
            return $(this).data('id');
        }).get();

        $('#disallow-execution-status-ids').val(JSON.stringify(ids));
    }

    function prepareRepositoryAlowedRoles() {
        var ids = $('#repository-roles-allowed option:selected').map(function() {
            return $(this).data('id');
        }).get();

        $('#allowed-repository-role-ids').val(JSON.stringify(ids));
    }

    function prepareAddXrayIssueTypeGroups() {
        var ids = $('#allow-add-xray-types option:selected').map(function() {
            return $(this).data('id');
        }).get();

        $('#allow-add-xray-types-ids').val(JSON.stringify(ids));
    }

    function initMultiSelectPicker($selectField, errorMessage) {
        var PreventSubmitMultiSelect = AJS.MultiSelect.extend({
            submitForm: function() {
                // do nothing
            }
        });

        return new PreventSubmitMultiSelect({
            element: $selectField,
            itemAttrDisplayed: "label",
            showDropdownButton: true,
            removeOnUnSelect: false,
            submitInputVal: false,
            errorMessage: errorMessage,
            maxInlineResultsDisplayed: 30
        });
    }

    $(document).ready(function() {
        AJS.messages.setup();

        $('#set-final-testrun-status-option').change(function() {
            $('#can-execute-testrun-inline-option').attr("disabled", !this.checked);
        });

        AJS.$("#workflow-resolved-status").change(function() {
            AJS.$("#resolution-option").attr("disabled", "none" === this.value);
        });

        var testExecStatusesErrorMessage = AJS.I18n.getText("raven-admin-config.requirement-coverage.ignore-statuses.error");
        disallowedTestExecStatuses = initMultiSelectPicker($('#disallow-execution-statuses'), testExecStatusesErrorMessage);

        var testStatusesErrorMessage = AJS.I18n.getText("raven-admin-config.requirement-coverage.ignore-statuses.error");
        disallowedTestStatuses = initMultiSelectPicker($('#disallow-execution-test-statuses'), testStatusesErrorMessage);

        var testStatusesErrorMessage = AJS.I18n.getText("raven-admin-config.requirement-coverage.ignore-statuses.error");
        allowedRoles = initMultiSelectPicker($('#repository-roles-allowed'), testStatusesErrorMessage);

        var goupsErrorMessage = AJS.I18n.getText("raven-admin-config.invalid.group");
        initMultiSelectPicker($('#allow-add-xray-types'), goupsErrorMessage);
        var form = document.getElementById('general-form');
        if (form) {
            if (form.attachEvent) {
                form.attachEvent("onsubmit", formSubmitListener);
            } else {
                form.addEventListener("submit", formSubmitListener);
            }
        }

        $('.aui-message.success').delay(5000).fadeOut('slow');
    });
})(AJS.$);