(function($) {

	function formSubmitListener() {
		prepareRequirementStatuses();
        prepareRequirementLabels();
		prepareTestStatuses();

		return true;
	}

	function prepareRequirementStatuses() {
		var ids = $('#ignored-requirement-statuses option:selected').map(function() { 
			return $(this).data('id');
		}).get();

		$('#ignored-requirement-status-ids').val(JSON.stringify(ids));
	}

    function prepareRequirementLabels() {
        var ids = $('#ignored-requirement-labels option:selected').map(function() {
            return $(this).val();
        }).get();

        $('#ignored-requirement-labels-ids').val(JSON.stringify(ids));
    }

	function prepareTestStatuses() {
		var ids = $('#ignored-test-statuses option:selected').map(function() {
            return $(this).data('id');
        }).get();

        $('#ignored-test-status-ids').val(JSON.stringify(ids));
	}

    function initMultiSelectPicker($selectField) {
        var PreventSubmitMultiSelect = AJS.MultiSelect.extend({
            submitForm: function () {
                // do nothing
            }
        });

        new PreventSubmitMultiSelect({
            element: $selectField,
            itemAttrDisplayed: "label",
            showDropdownButton: true,
            removeOnUnSelect: false,
            submitInputVal: false,
            errorMessage: AJS.I18n.getText("raven-admin-config.requirement-coverage.ignore-statuses.error"),
            maxInlineResultsDisplayed: 15
        });
    }

    function initLabelPicker($selectField) {
        var getDefaultOptionLabelPicker = AJS.LabelPicker.extend({
            _getDefaultOptions: function () {
                return jQuery.extend(true, this._super(), {
                    ajaxOptions: {
                        url: contextPath + "/rest/api/1.0/labels/suggest",
                        query: true,
                        formatResponse: this._formatResponse
                    },
                    removeDuplicates: true,
                    removeOnUnSelect: true,
                    userEnteredOptionsMsg: AJS.I18n.getText("raven-admin-config.requirement-coverage.ignore-requirements-in-labels.add-label-description")
                });
            },
        });
        
        new getDefaultOptionLabelPicker({
            element: $selectField,
            itemAttrDisplayed: "label",
            showDropdownButton: true,
            removeOnUnSelect: false,
            submitInputVal: false,
            errorMessage: AJS.I18n.getText("raven-admin-config.requirement-coverage.ignore-requirements-in-labels.error"),
            maxInlineResultsDisplayed: 15
        });
    }

	$(document).ready( function() {
		AJS.messages.setup();

		initMultiSelectPicker($('#ignored-requirement-statuses'));
        initLabelPicker($('#ignored-requirement-labels'));
        initMultiSelectPicker($('#ignored-test-statuses'));

        var form = document.getElementById('requirement-coverage-form');
        if (form.attachEvent) {
            form.attachEvent("submit", formSubmitListener);
        } else {
            form.addEventListener("submit", formSubmitListener);
        }

		$('.aui-message.success').delay(5000).fadeOut('slow');
	});
})(AJS.$);
