(function($) {
    
	window.RAVEN = window.RAVEN || {};
	RAVEN.FormDialog = JIRA.FormDialog.extend({
		_getFormDataAsObject: function() {
			var data = new FormData(this.$form[0]);
			data.append('inline', true);
			data.append('decorator', 'dialog');
			return data;
		}
	});

    JIRA.Dialogs.importTestResultsFromTest = new RAVEN.FormDialog({
        id: "raven-import-step-dialog",
        trigger: "#raven-from-test-link",
        width: 1000,
        ajaxOptions: JIRA.Dialogs.getDefaultAjaxOptions,
        onSuccessfulSubmit : JIRA.Dialogs.storeCurrentIssueIdOnSucessfulSubmit,
			submitAjaxOptions: {
			type: "post",
            data: {
                inline: true,
                decorator: "dialog"
            },
			processData: false,
			contentType: false,
			mimeType: 'multipart/form-data',
            dataType: "html"
        },

    });
   JIRA.Dialogs.importTestResultsFromTest.onContentReady(initImportFromTest);

    function initImportFromTest() {
            new AJS.SingleSelect({
                element: $('#raven-field-test-picker'),
                showDropdownButton: true,
                submitInputVal: true,
                noQueryNoRequest: false,
                revertOnInvalid: true,
                loadOnInit: true,
                ajaxOptions: {
                    query: true,
                    formatResponse: function (data) {
                        var optgroup = new AJS.GroupDescriptor({
                            weight: 0,
                            id: "all-test-issues-opt-group",
                            replace: true,
                            label: data.sections[0].sub
                        });

                        $(data.sections[0].issues).each(function(i, issue) {
                            var item = new AJS.ItemDescriptor({
                                value: issue.key,
                                label: issue.key + ' - ' + issue.summary,
                                icon: AJS.contextPath() + issue.img,
                                allowDuplicate: false,
                                selected: 'selected'
                            });
                            optgroup.addItem(item);
                        });
                        return [optgroup];
                    }
                }
            });
    }

    JIRA.Dialogs.importTestResults = new RAVEN.FormDialog({
        id: "raven-import-step-dialog",
        trigger: "#raven-from-csv-link",
        ajaxOptions: JIRA.Dialogs.getDefaultAjaxOptions,
        onSuccessfulSubmit : JIRA.Dialogs.storeCurrentIssueIdOnSucessfulSubmit,
        submitAjaxOptions: {
            type: "post",
            data: {
                inline: true,
                decorator: "dialog"
            },
            processData: false,
            contentType: false,
            mimeType: 'multipart/form-data',
            dataType: "html"
        }

    });
    
    JIRA.Dialogs.importTestResults = new RAVEN.FormDialog({
        id: "raven-import-step-dialog",
        trigger: "#raven-from-json-link",
        ajaxOptions: JIRA.Dialogs.getDefaultAjaxOptions,		
        onSuccessfulSubmit : JIRA.Dialogs.storeCurrentIssueIdOnSucessfulSubmit,
			submitAjaxOptions: {
			type: "post",
            data: {
                inline: true,
                decorator: "dialog"
            },
			processData: false,
			contentType: false,
			mimeType: 'multipart/form-data',
            dataType: "html"
        }

    });
    
    JIRA.Dialogs.importTestResults = new RAVEN.FormDialog({
        id: "raven-import-step-dialog",
        trigger: "#raven-from-excel-link",
        width: 1000,
        ajaxOptions: JIRA.Dialogs.getDefaultAjaxOptions,
        onSuccessfulSubmit : JIRA.Dialogs.storeCurrentIssueIdOnSucessfulSubmit,
			submitAjaxOptions: {
			type: "post",
            data: {
                inline: true,
                decorator: "dialog"
            },
			processData: false,
			contentType: false,
			mimeType: 'multipart/form-data',
            dataType: "html"
        }
    });
    
    $(document).on("change",".select#import",function(){
    	$("input#importFields").val($(".select#import").val());
    });
    
    $(document).on("click","#raven-from-excel-link", function(){
    	AJS.messages.setup();
    	$("#raven-import-step-dialog").focus();
    	$(document).bind('paste', function(e){
    		if($("#raven-import-step-dialog").length > 0) {
	    		 clipboardData = e.originalEvent.clipboardData || window.clipboardData;
	    		 pastedData = clipboardData.getData('Text');
	
	    		 renderStepsPreview(pastedData);
    		}
    	});
    });

    $(document).on("change", "#raven-field-test-picker", function() {
        var testKey = $('#raven-field-test-picker').find(":selected").val();

        if(testKey !== null && testKey !== undefined && testKey !== '') {
            var path = AJS.contextPath() + '/rest/raven/1.0/test/' + testKey + '/steps/';

            $.ajax({
                type: "GET",
                url: path,
                processData: true,
                async: true,
                contentType: "application/json",
                error: function (qXHR, textStatus, errorThrown) {
                    if (errorThrown && errorThrown.trim() != '') {
                        errorThrown = errorThrown + ': ' + qXHR.responseText;
                    } else {
                        errorThrown = qXHR.responseText;
                    }

                    message(AJS.I18n.getText('view-issue-test-section.manualsteps.nosteps'), errorThrown)
                },
                success: function (data, textStatus, jqXHR) {
                    $("#test-steps-table").html(RAVEN.Dialogs.ImportSteps.testStepsSelectorDialog({steps: data}));
                    $("#raven-import-step-dialog").css("margin-top",-$("#raven-import-step-dialog").height()/2);

                    $("#test-steps-entries-table #column-check-all .selectAll").change(function () {
                        if (this.checked) {
                            $('#test-steps-entries-table .selectStep').prop('checked', true);
                        } else {
                            $('#test-steps-entries-table .selectStep').prop('checked', false);
                        }

                        setSteps();
                    });

                    $("#test-steps-entries-table .selectStep").change(function () {
                        // Check if all steps are checked. If so, then check the bulk checkbox
                        if ($('#test-steps-entries-table .selectStep:checked').length == $('#test-steps-entries-table .selectStep').length) {
                            $('#test-steps-entries-table #column-check-all .selectAll').prop('checked', true);
                        } else {
                            $('#test-steps-entries-table #column-check-all .selectAll').prop('checked', false);
                        }

                        setSteps();
                    });
                }
            });
        }
    });

    function setSteps() {
        var selectedSteps = [];
        $("#test-steps-entries-table tbody input:checked").each(function() {
            selectedSteps.push($(this).attr("id"));
        });
        $('#stepIds').val(JSON.stringify(selectedSteps));
    }

    $(document).on('click', '#defaultExcel', function(e) {
        var input = $(this);
        if (!input.is(':checked')) {
            $("#delimiterCsv").removeAttr("disabled");
        } else {
            $("#delimiterCsv").attr("disabled","disabled");
            $("#delimiterCsv").val("\\t");
        }
    });

    var lockPasteOperation = false;
    function renderStepsPreview(steps){
        if (lockPasteOperation === true) {
            return;
        }
        lockPasteOperation = true;
        var columnLayout = $("input#importFields").val();
        var defaultExcel = $("#defaultExcel").is(":checked");
        var path = "/rest/raven/1.0/teststeps?layout=" + columnLayout;

        if(!defaultExcel) {
            path = path + "&delimiterCsv=" + $("#delimiterCsv").val();
        }

        $("#aui-message-bar-excel").empty();
        $.ajax({
            type: "POST",
            url: AJS.contextPath() + path,
            async: true,
            data: steps,
            contentType: "application/json",
            success: function(data) {
                $("input#excelSteps").val(steps);

                $(".steps-preview").html(RAVEN.Dialogs.ImportSteps.table({steps:data,columnLayout:columnLayout}));
                $(".steps-preview").removeClass("hidden");
                $("#raven-import-step-dialog").css("margin-top",-$("#raven-import-step-dialog").height()/2);
            },
            error: function(xhr, ajaxOptions, thrownError) {
                $(".steps-preview").empty();
                AJS.messages.error('#aui-message-bar-excel', {
                    title: AJS.I18n.getText("import-step.error.excel.title"),
                    body: AJS.I18n.getText("import-step.error.excel.body")
                });
            },
            complete: function() {
                lockPasteOperation = false;
            }
        });
    }
    
})(AJS.$);