RAVEN.namespace("RAVEN.gadget.fields");

RAVEN.gadget.fields.filterPicker = function (gadget, userpref) {
    return RAVEN.gadget.fields.filterPicker2(
        gadget,
        userpref,
        gadget.projectOrFilterName,
        gadget.getMsg("gadget.common.filter.label")
    );
};

RAVEN.gadget.fields.filterPicker2 = function(gadget, userpref, filterName, label){
    if (!filterName){
        filterName = gadget.getMsg("gadget.common.filter.none.selected");
    }

    return {
        userpref: userpref,
        label: label,
        description: gadget.getMsg("gadget.common.filter.description"),
        id: "proj_filter_picker_" + userpref,
        type: "callbackBuilder",
        callback: function(parentDiv){
            parentDiv.append(
                AJS.$("<input/>").attr({
                    id: "filter_" + userpref + "_id",
                    type: "hidden",
                    name: userpref
                }).val(gadget.getPref(userpref))
            ).append(
                AJS.$("<span/>").attr({id:"filter_" + userpref + "_name"}).addClass("filterpicker-value-name field-value").text(filterName)
            );
            parentDiv.append(
                AJS.$("<div/>").attr("id", "quickfind-container").append(
                    AJS.$("<label/>").addClass("overlabel").attr({
                        "for":"quickfind",
                        id: "quickfind-label-" + userpref
                    }).text(gadget.getMsg("gadget.common.quick.find"))
                ).append(
                    AJS.$("<input class='text' />").attr("id", "quickfind-" + userpref)
                ).append(
                    AJS.$("<span class='button clear-filter' style='width:55px; float:right;'>Clear<span/>")
                ).append(
                    AJS.$("<span/>").addClass("inline-error")
                )
            );

            parentDiv.find('.clear-filter').click(function(e) {
                parentDiv.find("#filter_" + userpref + "_name").text(gadget.getMsg("gadget.common.filter.none.selected"));
                parentDiv.find("#filter_" + userpref + "_id").val("");
                gadget.savePref(userpref, "");
                return false;
            });

            if (gadget.isLocal()){
                parentDiv.append(
                    AJS.$("<a href='#'/>").addClass("advanced-search").attr({
                        id: "filter_" + userpref + "_advance",
                        title: gadget.getMsg("gadget.common.filterid.edit")
                    }).text(gadget.getMsg("gadget.common.advanced.search")).click(function(e){
                        var url = jQuery.ajaxSettings.baseUrl + "/secure/FilterPickerPopup.jspa?showProjects=false&field=" + userpref;
                        var windowVal = "filter_" + userpref + "_window";
                        var prefs = "width=800, height=500, resizable, scrollbars=yes";

                        var newWindow = window.open(url, windowVal, prefs);
                        newWindow.focus();
                        e.preventDefault();
                    })
                );
            }


            AJS.gadget.fields.applyOverLabel("quickfind-label-" + userpref);
            AJS.gadget.fields.autocomplete.Filters({
                fieldID: "quickfind-" + userpref,
                ajaxData: {},
                baseUrl: jQuery.ajaxSettings.baseUrl,
                relatedId: "filter_" + userpref + "_id",
                relatedDisplayId: "filter_" + userpref + "_name",
                filtersLabel: gadget.getMsg("gadget.common.filters"),
                gadget: gadget
            });
        }
    };
};