(function($) {
    var testSetView = null;

	function onNewContentAdded(e, context, reason) {
        if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad || reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            var $section = $('#raven-testsets');
            if ($section.length > 0) {
                if (!$section.attr('data-initialized') && RAVEN.Utils.isCurrentIssueValid($('#raven-test-testsets-issue-key').val())) {
                    initialize();
                }
            } else if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad) {
                destroy();
            }
        }
	}

    function initialize() {
        destroy();

        testSetView = new RAVEN.Test.TestSetsView();

        $('#raven-testsets').attr("data-initialized", "true");
    }

    function destroy() {
        if (testSetView) {
            testSetView.destroy();
            testSetView = null;
        }
    }

   	// register for NEW_CONTENT_ADDED
    JIRA.unbind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);
    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);

    $(document).ready(function() {
        $(document).on(RAVEN.Test.TestSetsView.REFRESH_VIEW, '#raven-testsets', function(e) {
            initialize();
        });
    });

})(AJS.$);
