(function($) {

    var testSetView = null;

    function onNewContentAdded(e, context, reason) {
        if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad ||  reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            var $section = $('#testsets-section');
            if ($section.length > 0 && !$section.attr('data-initialized')) {
                initialize();
            }
        }
    }

    function initialize() {
        if (testSetView) {
            testSetView.destroy();
            testSetView = null;
        }

        testSetView = new RAVEN.Project.TestSet.TestSetsView();

        $('#testsets-section').attr("data-initialized", "true");
    }

    // register for NEW_CONTENT_ADDED
    JIRA.unbind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);
    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);

    $(document).ready(function() {
        $(document).on(RAVEN.Project.TestSet.TestSetsView.REFRESH_VIEW, '#testsets-section', function(e) {
            initialize();
        });
    });

})(AJS.$);
