(function ($) {

	window.RAVEN = window.RAVEN || {};

	RAVEN.RestfulTable.InlineDialogEditView = RAVEN.RestfulTable.HtmlWikiEditView.extend({

		render: function (self) {
			var value = RAVEN.RestfulTable.InlineDialogEditView.__super__.render.apply(this, [self]);

			var modelId = self.model.attributes.index;
			if (!modelId) {
				modelId = 'new';
			}

			var textareaId = 'content-' + modelId + '-' + self.columnId;
			var input = '<textarea id="' + textareaId + '" name="' + self.columnId + '" class="edit-content"></textarea>';

			var triggerId = modelId + '-' + self.columnId + '-inline-dialog-trigger';
			var inlineDialogTrigger = '<button class="aui-button aui-button-subtle" style="float:right;" type="button" href="#" id="' + triggerId + '">\
    				<span class="aui-icon aui-icon-small icon-inline-dialog-sml">'+AJS.I18n.getText('common.action.edit')+'</span>\
				</button>';
			var $content = $('<div></div>').html(input + inlineDialogTrigger);

            var $input = $content.find('#' + textareaId);
            var $inlineDialogTrigger = $content.find('#' + triggerId);

            $input.text(value);
			var $popup = this._createPopup($inlineDialogTrigger, $input, modelId, self.columnId, self.header);
/*
			$inlineDialogTrigger.click(function(e) {
				//$popup.refresh();
				$popup.show(e);
				return false;
			});
*/
			return $content;
		},

		_createPopup: function($trigger, $input, modelId, columnId, header) {
			var that = this;

			var textareaId = 'inline-content-' + modelId + '-' + columnId;
			var dialogId = modelId + '-' + columnId;

			// remove previous dialog
			$('#inline-dialog-' + dialogId).remove();

			return AJS.InlineDialog($trigger, dialogId, function(content, trigger, showPopup) {
				// HACK: https://jira.atlassian.com/browse/JRA-24215
				$(content).click(function(e) {
					if ($(e.target).closest('.aui-dropdown2-trigger').length == 0) {
						$('#inline-dialog-' + dialogId + ' .aui-dropdown2-trigger.aui-dropdown2-active, #inline-dialog-' + dialogId + ' .aui-dropdown2-trigger.aui-dropdown2-active').trigger("aui-button-invoke");
					}

					e.stopPropagation()
				});

				// get current value from textarea
				var value = $input.val();

				var heading = '#' + modelId + ' - ' + columnId;
				if (modelId === 'new') {
					heading = AJS.I18n.getText('restful.table.editrow.inlinedialog.new', header);
				}

	        	content.css({"padding":"10px"}).html(
	        		'<h3>' + heading + '</h3>\
	        		<form action="#" class="aui" style="min-height: 256px;">\
                        <div class="aui-field-wikiedit path-input">\
                            <div class="wiki-edit">\
                                <div class="wiki-edit-content" id="step-wiki-edit">\
                                    <textarea wrap="virtual" rows="10" id="'+textareaId+'" class="textarea long-field wiki-textfield mentionable" style="resize: none;">'+value+'</textarea>\
                                    <div class="content-inner">\
                                    </div>\
                                </div>\
                            </div>\
                        </div>\
                    </form>\
	        		<button id="content-edit-done" class="aui-button" style="margin:0;">'+AJS.I18n.getText('common.label.done')+'</button>');

				$(document).off('showLayer.raven').on("showLayer.raven", function(e, type, dialog) {
					if (dialog && type === 'inlineDialog' && dialog.id === dialogId) {
						var inlineDialog = document.getElementById('inline-dialog-' + dialogId);
	    				if (!that._isScrolledIntoView(inlineDialog)) {
	    					var offset = $(inlineDialog).offset();
	    					$('html, body').animate({
							    scrollTop: offset.top - 20,
							    scrollLeft: offset.left
							});
                    }
					}
				});

				$(document).off('click.raven-manual-steps');
				$(document).on('click.raven-manual-steps', '#inline-dialog-' + dialogId + ' .wiki-edit-dropdown, #inline-dialog-' + dialogId + ' .wiki-edit-picker,' +
                    ' .aui-dropdown2.aui-style-default.wiki-edit-dropdown, .aui-dropdown2.aui-style-default.wiki-edit-picker, .mce-container-body', function(e) {
					// stop propagation in order to prevent closing inline dialog
					e.stopPropagation();
				});

				$(document).off("click.raven-inline").on("click.raven-inline", "body", function () {
                    $(document).off("click.raven-inline");
                    var value = $("#inline-dialog-" + dialogId).find("#"+textareaId).val();
                    $input.val(value);
                    $("#inline-dialog-" + dialogId).hide();
                });

				showPopup();

                 // if jira >= 7.2
				if($("#use-rich-text-editor").val() === "true") {
					 var renderData = {
						 forWysiwyg: true,
						 issueKey: JIRA.Issue.getIssueKey(),
						 rendererType: "atlassian-wiki-renderer",
						 unrenderedMarkup: value
					 };

					 $('#inline-dialog-' + dialogId).block();
					 $.ajax({
						type: "POST",
						url: AJS.contextPath() + '/rest/api/1.0/render',
						contentType: "application/json",
						data: JSON.stringify(renderData),
						success: function (data) {
							content.find("#step-wiki-edit").append('<rich-editor contenteditable="true" data-issue-key="' + JIRA.Issue.getIssueKey() + '" data-content-present="true">' + data + '</rich-editor>')
							content.find("#content-edit-done").css("float", "right");
						},
						error: function (qXHR, textStatus, errorThrown) {
							// might wanna do something else here
                            if (errorThrown && errorThrown.trim() != '') {
                                errorThrown = errorThrown + ': ' + qXHR.responseText;
                            } else {
                                errorThrown = qXHR.responseText;
                            }

							console.log("Error rendering rich text",errorThrown);
						},
						complete: function () {
							$('#inline-dialog-' + dialogId).unblock();
						}
					 });
                } else if ($("#move-button").val() === "true") { // might be jira 7.2 and have experimental rich text
                    content.find("#content-edit-done").css("float", "right");
				}

	        	return false;
	    	},
	    	{
	    		// options
    			width: 600,
    			//noBind: true,
    			cacheContent: false,
    			hideDelay: null,
                persistent: true,
    			initCallback: function() {
    				var popup = this.popup;

    				var $doneButton = popup.find('#content-edit-done');
					$doneButton.click(function(e) {
						var value = popup.find('#' + textareaId).val();
						$input.val(value);

						popup.hide();
					});
    			},
    			hideCallback: function() {
    				var popup = this.popup;
    				var value = popup.find('#' + textareaId).val();
					$input.val(value);
    			}
    		});
		},

		_isScrolledIntoView: function(elem) {
		    var docViewTop = $(window).scrollTop();
		    var docViewBottom = docViewTop + $(window).height();

		    var offset = $(elem).offset();
			var elemTop = offset.top;
			var elemBottom = elemTop + $(elem).height();

			return ((elemBottom <= docViewBottom) && (elemTop >= docViewTop));
		}

	});

})(AJS.$);